;-- ein Skript zum Erstellen und drucken von QR Codes
;-- die Codes kommen von www.qrserver.com

;-- Variablen setzen
pfad_ordner = %A_AppData%\QRCode
png = %A_AppData%\QRCode\qr_temp.png
labelliste = %A_AppData%\QRCode\qr_labelliste.txt
drucker = %A_AppData%\QRCode\qrcode_drucker.ini

;-- sicherstellen, dass der Config Ordner und die Config Dateien vorhanden sind
IfNotExist, %pfad_ordner%
{
 FileCreateDir, %pfad_ordner%
 if(errorlevel != 0)
 {
  Msgbox, 0, Fehler, Der Ordner %pfad_ordner% konnte nicht erstellt werden.
  exitapp
 }
}
IfNotExist, %labelliste%
{
 FileAppend, , %labelliste%
 if(errorlevel != 0)
 {
  Msgbox, 0, Fehler, Die Datei %labelliste% konnte nicht erstellt werden.
  exitapp
 }
}
IfNotExist, %drucker%
{
 inputbox, druckername, QR Code Drucker, Geben sie den Namen des Druckers ein`, mit dem die QR Codes gedruckt werden sollen.`nWenn nichts eingegeben wird`, verwendet das Programm den Standarddrucker.
 FileAppend, %druckername%, %drucker%
 if(errorlevel != 0)
 {
  Msgbox, 0, Fehler, Die Datei %drucker% konnte nicht erstellt werden.
  exitapp
 }
}
IfExist, %png%
{
 FileDelete, %png%
 if(errorlevel != 0)
 {
  Msgbox, 0, Fehler, Die Datei %png% existiert bereits und konnte nicht gelscht werden.
  exitapp
 }
}

;-- GUI
Gui, add, text, section, Text fr QR Code (max 60 zeichen):
Gui, add, edit, vqrtext ys w600,
Gui, add, Button, default section, Ok
Gui, Add, Button, ys, Labelliste
Gui, Add, Button, ys, Druckername
Gui, Show,, QR Code drucken
return

guiclose:
GuiEscape:
exitApp

ButtonLabelliste:
run, %labelliste%
return

ButtonDruckername:
run, %drucker%
return

ButtonOK:
;-- Inhalt der Variablen bergeben
guiControlGet, qrtext
;-- Druckernamen ermitteln
FileReadLine, druckername, %drucker%, 1

;-- Lnge von QRText berprfen
Stringlen, qrtext_length, qrtext
if((qrtext_length == 0) || (qrtext_length > 60))
{
 if(qrtext_length == 0)
  msgbox, 0, Text fehlt, Es wurde kein Text eingegeben.
 else
  msgbox, 0, Text zu lang, % "Der eingegebene Text ist um " . (qrtext_length-60) . "Zeichen zu lang (max 60 Zeichen erlaubt)."
}
else
{
 URLDownloadToFile, http://api.qrserver.com/v1/create-qr-code/?data=%qrtext%, %png%
 error := PrintImage(png, druckername)

 if(error == -1)
  msgbox, 0, QR_Temp.png, Die Datei wurde nicht gefunden oder beim Download ist ein Fehler aufgetreten.
 if(error > 0)
  msgbox, 0, Fehler, Beim Drucken ist ein Fehler aufgetreten`nFehlercode = %error%
 if(error == 0) ;-- wenn alles in Ordnung ist
 {
  ;-- lsche das Eingabefeld, bewege den Fokus wieder auf das Feld und warte auf eine neue Eingabe
  GuiControl, , qrtext, 
  GuiControl, focus, qrtext
 }

 ;-- temporres PNG lschen und das Label zur Labelliste (Textfile) hinzufgen
 filedelete, %png%
 fileappend, %qrtext%`n, %labelliste%
}
return

;-- Funktionen
PrintImage(image, printer)
{ 
If !FileExist(image) 
 Return, -1 
If (printer = "") 
 printer := GetDefaultPrinter() 

;-- drucken
RunWait, %comspec% /c "rundll32.exe shimgvw.dll`,ImageView_PrintTo /pt "%image%" "%printer%"", UseErrorLevel, Hide
Return, Errorlevel 
}

;-- GetDefaultPrinter() & SetDefaultPrinter() by SKAN 
;-- http://www.autohotkey.com/forum/viewtopic.php?t=18321p=115806#115806 
;-- SetDefaultPrinter wird in diesem Skript zwar nicht bentigt, ich lasse es aber der Vollstndigkeit halber mal stehen
GetDefaultPrinter()
{ 
nSize := VarSetCapacity(sPrinter, 256) 
DllCall("winspool.drv\GetDefaultPrinterA", "Str", sPrinter, "UintP", nSize) 
Return, sPrinter 
} 

SetDefaultPrinter(sPrinter)
{ 
Return, DllCall("winspool.drv\SetDefaultPrinterA", "str", sPrinter) 
}
